## ettercap 0.7.5.3

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8)
project(ettercap C)

set(VERSION "0.7.5")

option(ENABLE_CURSES "Enable curses interface" ON)
option(ENABLE_GTK "Enable GTK interface" ON)
option(ENABLE_SSL "Enable SSL support" ON)
option(ENABLE_PLUGINS "Enable plugins support" ON)
option(ENABLE_IPV6 "Enable IPv6 support" OFF)

set(MACPORTS_BASE_DIRECTORY "/opt/local" CACHE PATH "MacPorts installation base directory")
set(SPECIAL_LIB_DIR "" CACHE PATH "Special (non-traditional) directory where libraries are installed")

include(CMakeModules/CheckVariableInHeaders.cmake)
include(CMakeFiles/os_test.cmake)

#Check and see if we're running Darwin, specify the CMAKE_LIBARY_PATH to do so
if(OS_DARWIN)
	set(CMAKE_SYSTEM_NAME Darwin)
	set(CMAKE_LIBRARY_PATH ${MACPORTS_BASE_DIRECTORY}/lib ${CMAKE_LIBRARY_PATH})
	set(CMAKE_INCLUDE_PATH ${MACPORTS_BASE_DIRECTORY}/include ${CMAKE_INCLUDE_PATH})
else(OS_DARWIN)
	set(CMAKE_LIBRARY_PATH ${CMAKE_LIBRARY_PATH} /usr/lib64 /usr/lib32)
endif(OS_DARWIN)

include(CMakeFiles/headers_check.cmake)
include(CMakeFiles/lib_check.cmake)
include(CMakeFiles/variable_check.cmake)

set(INSTALL_PREFIX ${CMAKE_INSTALL_PREFIX} CACHE PATH "Installation prefix")
set(INSTALL_SYSCONFDIR /etc CACHE PATH "System configuration directory")
set(INSTALL_LIBDIR ${INSTALL_PREFIX}/lib${LIB_SUFFIX} CACHE PATH "Library installation directory")
set(INSTALL_DATADIR ${INSTALL_PREFIX}/share CACHE PATH "Data installation directory")
set(INSTALL_EXECPREFIX ${INSTALL_PREFIX} CACHE PATH "")
set(INSTALL_BINDIR ${INSTALL_PREFIX}/bin CACHE PATH "Binary files installation directory")
set(MAN_INSTALLDIR ${INSTALL_PREFIX}/share/man CACHE PATH "Path for manual pages") 

set(CMAKE_C_FLAGS_DEBUG "-O0 -ggdb3 -DDEBUG -Wall -Wno-pointer-sign -pg" CACHE STRING "" FORCE)
set(CMAKE_C_FLAGS_RELEASE "-O2 -w" CACHE STRING "" FORCE)

if(OS_DARWIN)
set(CMAKE_EXE_LINKER_FLAGS "-Wl" CACHE STRING "" FORCE)
set(CMAKE_EXE_LINKER_FLAGS_DEBUG "-Wl -pg" CACHE STRING "" FORCE)
set(CMAKE_MODULE_LINKER_FLAGS "-Wl" CACHE STRING "" FORCE)
else(OS_DARWIN)
set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} -Wl,-export-dynamic" CACHE STRING "" FORCE)
set(CMAKE_EXE_LINKER_FLAGS_DEBUG "-Wl,-export-dynamic -pg" CACHE STRING "" FORCE)
set(CMAKE_MODULE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} -Wl,-export-dynamic" CACHE STRING "" FORCE)
endif(OS_DARWIN)

set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} ${CMAKE_SOURCE_DIR}/CMakeModules)


include_directories(include)

add_subdirectory(src)

if(HAVE_PLUGINS)
    if(OS_MINGW)
        message("Sorry, plugins support on Windows is currently unavailable")
    else(OS_MINGW)
        add_subdirectory(plug-ins)
    endif(OS_MINGW)
endif(HAVE_PLUGINS)
add_subdirectory(utils)
add_subdirectory(share)
add_subdirectory(man)

if(ENABLE_IPV6)
    set(WITH_IPV6 TRUE)
endif(ENABLE_IPV6)

# This line should ALWAYS be after all options are defined
configure_file(include/config.h.cmake ${CMAKE_SOURCE_DIR}/include/config.h)

=== man/CMakeLists.txt ===
# Add man page custom target
find_program(GROFF_EXECUTABLE NAMES groff)
find_program(PS2PDF13_EXECUTABLE NAMES ps2pdf13)

set (MAN_NAMES ettercap.8 etterfilter.8 etterlog.8 etter.conf.5)
set(MAN_FILES)
set(PDF_FILES)

if (ENABLE_PLUGINS)
        set(MAN_NAMES ${MAN_NAMES} ettercap_plugins.8)
endif(ENABLE_PLUGINS)

if (ENABLE_CURSES)
        set(MAN_NAMES ${MAN_NAMES} ettercap_curses.8)
endif(ENABLE_CURSES)

foreach (m IN LISTS MAN_NAMES)
        set(mf ${CMAKE_BINARY_DIR}/man/${m})
        set(ps ${CMAKE_BINARY_DIR}/man/${m}.ps)
        set(pdf ${CMAKE_BINARY_DIR}/man/${m}.pdf)

        add_custom_command(OUTPUT ${mf}.ps
        COMMAND ${GROFF_EXECUTABLE} -mandoc -Tps ${mf} > ${ps}
        WORKING_DIRECTORY ${CMAKE_BINARY_DIR}
        COMMENT "Building manpage ${mf}"
        VERBATIM)
        list(APPEND MAN_FILES ${mf})

        add_custom_command(OUTPUT ${pdf}
        COMMAND ${PS2PDF13_EXECUTABLE} ${ps} ${pdf}
        WORKING_DIRECTORY ${CMAKE_BINARY_DIR}
	DEPENDS ${mf}.ps
        COMMENT "Creating PDF for ${ps}"
        VERBATIM)
        list(APPEND PDF_FILES ${pdf})
endforeach()

add_custom_target(man ALL DEPENDS ${MAN_FILES})
add_custom_target(pdf ALL DEPENDS ${PDF_FILES})

install(FILES ${CMAKE_BINARY_DIR}/man/ettercap.8 ${CMAKE_BINARY_DIR}/man/etterfilter.8 ${CMAKE_BINARY_DIR}/man/etterlog.8 DESTINATION ${MAN_INSTALLDIR}/man8/)
configure_file("ettercap.8.in" "ettercap.8")
configure_file("etterfilter.8.in" "etterfilter.8")
configure_file("etterlog.8.in" "etterlog.8")
configure_file("etter.conf.5.in" "etter.conf.5")

if (ENABLE_PLUGINS)
        install(FILES ${CMAKE_BINARY_DIR}/man/ettercap_plugins.8 DESTINATION ${MAN_INSTALLDIR}/man8/)
	configure_file("ettercap_plugins.8.in" "ettercap_plugins.8")
endif(ENABLE_PLUGINS)

if (ENABLE_CURSES)
        install(FILES ${CMAKE_BINARY_DIR}/man/ettercap_curses.8 DESTINATION ${MAN_INSTALLDIR}/man8/)
	configure_file("ettercap_curses.8.in" "ettercap_curses.8")
endif(ENABLE_CURSES)

install(FILES ${CMAKE_BINARY_DIR}/man/etter.conf.5 DESTINATION ${MAN_INSTALLDIR}/man5/)

=== plug-ins/CMakeLists.txt ===

add_library(arp_cop MODULE arp_cop/arp_cop.c)
set_target_properties(arp_cop PROPERTIES PREFIX "ec_")

add_library(autoadd MODULE autoadd/autoadd.c)
set_target_properties(autoadd PROPERTIES PREFIX "ec_")

add_library(chk_poison MODULE chk_poison/chk_poison.c)
set_target_properties(chk_poison PROPERTIES PREFIX "ec_")

add_library(dns_spoof MODULE dns_spoof/dns_spoof.c)
target_link_libraries(dns_spoof ${HAVE_RESOLV})
set_target_properties(dns_spoof PROPERTIES PREFIX "ec_")

add_library(dos_attack MODULE dos_attack/dos_attack.c)
target_link_libraries(dos_attack ${HAVE_LIBNET})
set_target_properties(dos_attack PROPERTIES PREFIX "ec_")

add_library(dummy MODULE dummy/dummy.c)
set_target_properties(dummy PROPERTIES PREFIX "ec_")

add_library(find_conn MODULE find_conn/find_conn.c)
set_target_properties(find_conn PROPERTIES PREFIX "ec_")

add_library(find_ettercap MODULE find_ettercap/find_ettercap.c)
set_target_properties(find_ettercap PROPERTIES PREFIX "ec_")

add_library(find_ip MODULE find_ip/find_ip.c)
set_target_properties(find_ip PROPERTIES PREFIX "ec_")

add_library(finger MODULE finger/finger.c)
set_target_properties(finger PROPERTIES PREFIX "ec_")

add_library(finger_submit MODULE finger_submit/finger_submit.c)
set_target_properties(finger_submit PROPERTIES PREFIX "ec_")

add_library(gre_relay MODULE gre_relay/gre_relay.c)
set_target_properties(gre_relay PROPERTIES PREFIX "ec_")

add_library(gw_discover MODULE gw_discover/gw_discover.c)
set_target_properties(gw_discover PROPERTIES PREFIX "ec_")

add_library(isolate MODULE isolate/isolate.c)
set_target_properties(isolate PROPERTIES PREFIX "ec_")

add_library(link_type MODULE link_type/link_type.c)
set_target_properties(link_type PROPERTIES PREFIX "ec_")

add_library(nbns_spoof MODULE nbns_spoof/nbns_spoof.c)
set_target_properties(nbns_spoof PROPERTIES PREFIX "ec_")

add_library(sslstrip MODULE sslstrip/sslstrip.c)
target_link_libraries(sslstrip ${FOUND_LIBCURL} ${HAVE_PCRE})
set_target_properties(sslstrip PROPERTIES PREFIX "ec_")

add_library(pptp_chapms1 MODULE pptp_chapms1/pptp_chapms1.c)
set_target_properties(pptp_chapms1 PROPERTIES PREFIX "ec_")

add_library(pptp_clear MODULE pptp_clear/pptp_clear.c)
set_target_properties(pptp_clear PROPERTIES PREFIX "ec_")

add_library(pptp_pap MODULE pptp_pap/pptp_pap.c)
set_target_properties(pptp_pap PROPERTIES PREFIX "ec_")

add_library(pptp_reneg MODULE pptp_reneg/pptp_reneg.c)
set_target_properties(pptp_reneg PROPERTIES PREFIX "ec_")

add_library(rand_flood MODULE rand_flood/rand_flood.c)
set_target_properties(rand_flood PROPERTIES PREFIX "ec_")

add_library(remote_browser MODULE remote_browser/remote_browser.c)
set_target_properties(remote_browser PROPERTIES PREFIX "ec_")

add_library(reply_arp MODULE reply_arp/reply_arp.c)
set_target_properties(reply_arp PROPERTIES PREFIX "ec_")

add_library(repoison_arp MODULE repoison_arp/repoison_arp.c)
set_target_properties(repoison_arp PROPERTIES PREFIX "ec_")

add_library(scan_poisoner MODULE scan_poisoner/scan_poisoner.c)
set_target_properties(scan_poisoner PROPERTIES PREFIX "ec_")

add_library(search_promisc MODULE search_promisc/search_promisc.c)
set_target_properties(search_promisc PROPERTIES PREFIX "ec_")

add_library(smb_clear MODULE smb_clear/smb_clear.c)
set_target_properties(smb_clear PROPERTIES PREFIX "ec_")

add_library(smb_down MODULE smb_down/smb_down.c)
set_target_properties(smb_down PROPERTIES PREFIX "ec_")

add_library(smurf_attack MODULE smurf_attack/smurf_attack.c)
set_target_properties(smurf_attack PROPERTIES PREFIX "ec_")

add_library(stp_mangler MODULE stp_mangler/stp_mangler.c)
set_target_properties(stp_mangler PROPERTIES PREFIX "ec_")

set(PLUGINS arp_cop
autoadd
chk_poison
dns_spoof
dos_attack
dummy
find_conn
find_ettercap
find_ip
finger
finger_submit
gre_relay
gw_discover
isolate
link_type
nbns_spoof
sslstrip
pptp_chapms1
pptp_clear
pptp_pap
pptp_reneg
rand_flood
remote_browser
reply_arp
repoison_arp
scan_poisoner
search_promisc
smb_clear
smb_down
smurf_attack
stp_mangler)

foreach(plugin ${PLUGINS})
	target_link_libraries(${plugin} ettercap)
endforeach(plugin)

install(TARGETS
            arp_cop
            autoadd
            chk_poison
            dns_spoof
            dos_attack
            dummy
            find_conn
            find_ettercap
            find_ip
            finger
            finger_submit
            gre_relay
            gw_discover
            isolate
            link_type
            nbns_spoof
	    sslstrip
            pptp_chapms1
            pptp_clear
            pptp_pap
            pptp_reneg
            rand_flood
            remote_browser
            reply_arp
            repoison_arp
            scan_poisoner
            search_promisc
            smb_clear
            smb_down
            smurf_attack
            stp_mangler
        LIBRARY DESTINATION ${INSTALL_LIBDIR}/ettercap/
        PERMISSIONS OWNER_READ OWNER_WRITE OWNER_EXECUTE
                    GROUP_READ GROUP_EXECUTE
                    WORLD_READ WORLD_EXECUTE)

=== share/CMakeLists.txt ===
install(FILES etter.conf etter.dns etter.nbns DESTINATION ${INSTALL_SYSCONFDIR}/ettercap)

if(ENABLE_IPV6)
	install(FILES etter.conf.v6 DESTINATION ${INSTALL_SYSCONFDIR}/ettercap RENAME etter.conf)
else(ENABLE_IPV6)
	install(FILES etter.conf DESTINATION ${INSTALL_SYSCONFDIR}/ettercap)
endif(ENABLE_IPV6)

install(FILES
            ettercap.png
            etter.fields
            etter.filter
            etterfilter.cnt
            etter.filter.examples
            etter.filter.kill
            etter.filter.pcre
            etter.filter.ssh
            etterfilter.tbl
            etter.finger.mac
            etter.finger.os
            etterlog.dtd
            etter.mime
            etter.services
            etter.ssl.crt
        DESTINATION ${INSTALL_DATADIR}/ettercap)

=== src/CMakeLists.txt ===
set(EC_SRC
        ec_capture.c
        ec_checksum.c
        ec_conf.c
        ec_connbuf.c
        ec_conntrack.c
        ec_debug.c
        ec_decode.c
        ec_dispatcher.c
        ec_dissect.c
        ec_error.c
        ec_file.c
        ec_filter.c
        ec_fingerprint.c
        ec_format.c
        ec_globals.c
        ec_hash.c
        ec_hook.c
        ec_inet.c
        ec_inject.c
        ec_interfaces.c
        ec_log.c
        ec_main.c
        ec_manuf.c
        ec_mitm.c
        ec_network.c
        ec_packet.c
        ec_parser.c
        ec_passive.c
        ec_plugins.c
        ec_poll.c
        ec_profiles.c
        ec_resolv.c
        ec_scan.c
        ec_send.c
        ec_services.c
        ec_session.c
        ec_signals.c
        ec_sniff_bridge.c
        ec_sniff.c
        ec_sniff_unified.c
        ec_socket.c
        ec_sslwrap.c
        ec_stats.c
        ec_streambuf.c
        ec_strings.c
        ec_threads.c
        ec_ui.c
        ec_update.c

        dissectors/ec_bgp.c
        dissectors/ec_cvs.c
        dissectors/ec_dhcp.c
        dissectors/ec_ftp.c
        dissectors/ec_http.c
        dissectors/ec_icq.c
        dissectors/ec_imap.c
        dissectors/ec_irc.c
        dissectors/ec_iscsi.c
        dissectors/ec_ldap.c
        dissectors/ec_mongodb.c
        dissectors/ec_mountd.c
        dissectors/ec_msn.c
        dissectors/ec_mysql.c
        dissectors/ec_napster.c
        dissectors/ec_nbns.c
        dissectors/ec_nntp.c
        dissectors/ec_o5logon.c
        dissectors/ec_ospf.c
        dissectors/ec_pop.c
        dissectors/ec_postgresql.c
        dissectors/ec_portmap.c
        dissectors/ec_radius.c
        dissectors/ec_rcon.c
        dissectors/ec_rip.c
        dissectors/ec_rlogin.c
        dissectors/ec_smb.c
        dissectors/ec_smtp.c
        dissectors/ec_snmp.c
        dissectors/ec_socks.c
        dissectors/ec_telnet.c
        dissectors/ec_TN3270.c
        dissectors/ec_vnc.c
        dissectors/ec_vrrp.c
        dissectors/ec_x11.c
        dissectors/ec_ymsg.c

        mitm/ec_arp_poisoning.c
        mitm/ec_dhcp_spoofing.c
        mitm/ec_icmp_redirect.c
        mitm/ec_port_stealing.c

        protocols/ec_arp.c
        protocols/ec_cooked.c
        protocols/ec_eth.c
        protocols/ec_fddi.c
        protocols/ec_gre.c
        protocols/ec_icmp.c
        protocols/ec_ip.c
        protocols/ec_ppp.c
        protocols/ec_prism.c
        protocols/ec_radiotap.c
        protocols/ec_rawip.c
        protocols/ec_tcp.c
        protocols/ec_tr.c
        protocols/ec_udp.c
        protocols/ec_vlan.c
        protocols/ec_wifi.c
)

if(ENABLE_IPV6)
    set(EC_SRC ${EC_SRC} protocols/ec_icmp6.c protocols/ec_ip6.c mitm/ec_ip6nd_poison.c)
endif(ENABLE_IPV6)

if(HAVE_DN_EXPAND)
    set(EC_SRC ${EC_SRC} dissectors/ec_dns.c)
endif(HAVE_DN_EXPAND)

if(ENABLE_SSL)
   set(EC_SRC ${EC_SRC} dissectors/ec_ssh.c)
   set(EC_SRC ${EC_SRC} dissectors/ec_gg.c)
endif(ENABLE_SSL)

if(OS_LINUX)
    set(EC_SRC ${EC_SRC} os/ec_linux.c)
elseif(OS_BSD)
    set(EC_SRC ${EC_SRC} os/ec_bsd.c)
elseif(OS_DARWIN)
    set(EC_SRC ${EC_SRC} os/ec_darwin.c)
elseif(OS_MINGW)
    set(EC_SRC ${EC_SRC} os/ec_mingw.c)
elseif(OS_SOLARIS)
    set(EC_SRC ${EC_SRC} os/ec_solaris.c)
endif()

if(NOT HAVE_STRLCAT)
    set(EC_SRC ${EC_SRC} missing/strlcat.c)
endif(NOT HAVE_STRLCAT)
if(NOT HAVE_STRLCPY)
    set(EC_SRC ${EC_SRC} missing/strlcpy.c)
endif(NOT HAVE_STRLCPY)
if(NOT HAVE_STRSEP)
    set(EC_SRC ${EC_SRC} missing/strsep.c)
endif(NOT HAVE_STRSEP)
if(NOT HAVE_STRCASESTR)
    set(EC_SRC ${EC_SRC} missing/strcasestr.c)
endif(NOT HAVE_STRCASESTR)
if(NOT HAVE_MEMMEM)
    set(EC_SRC ${EC_SRC} missing/memmem.c)
endif(NOT HAVE_MEMMEM)
if(NOT HAVE_BASENAME)
    set(EC_SRC ${EC_SRC} missing/basename.c)
endif(NOT HAVE_BASENAME)

add_subdirectory(interfaces)

add_executable(ettercap ${EC_SRC})
target_link_libraries(ettercap ec_interfaces ${EC_LIBS})
set_target_properties(ettercap PROPERTIES ENABLE_EXPORTS TRUE)
install(TARGETS ettercap DESTINATION ${INSTALL_BINDIR})

=== utils/CMakeLists.txt ===
## Etterfilter

set(EF_SRC
            etterfilter/ef_compiler.c
            etterfilter/ef_ec_compat.c
            etterfilter/ef_encode.c
            etterfilter/ef_main.c
            etterfilter/ef_output.c
            etterfilter/ef_parser.c
            etterfilter/ef_tables.c
            etterfilter/ef_test.c
            ${CMAKE_SOURCE_DIR}/src/ec_error.c
            ${CMAKE_SOURCE_DIR}/src/ec_file.c
            ${CMAKE_SOURCE_DIR}/src/ec_filter.c
            ${CMAKE_SOURCE_DIR}/src/ec_strings.c
)

if(NOT HAVE_STRLCPY)
    set(EF_SRC ${EF_SRC} ${CMAKE_SOURCE_DIR}/src/missing/strlcpy.c)
endif(NOT HAVE_STRLCPY)

if(NOT HAVE_STRSEP)
    set(EF_SRC ${EF_SRC} ${CMAKE_SOURCE_DIR}/src/missing/strsep.c)
endif(NOT HAVE_STRSEP)

if(NOT HAVE_MEMMEM)
    set(EF_SRC ${EF_SRC} ${CMAKE_SOURCE_DIR}/src/missing/memmem.c)
endif(NOT HAVE_MEMMEM)

if(NOT HAVE_INET_ATON)
    set(EF_SRC ${EF_SRC} ${CMAKE_SOURCE_DIR}/src/missing/inet_aton.c)
endif(NOT HAVE_INET_ATON)

if(NOT HAVE_GETOPT_LONG)
    set(EF_SRC ${EF_SRC} ${CMAKE_SOURCE_DIR}/src/missing/getopt.c)
endif(NOT HAVE_GETOPT_LONG)

find_package(BISON)
find_package(FLEX)
BISON_TARGET(EF_PARSER etterfilter/ef_grammar.y ${CMAKE_CURRENT_BINARY_DIR}/ef_grammar.c)
FLEX_TARGET(EF_SCANNER etterfilter/ef_syntax.l ${CMAKE_CURRENT_BINARY_DIR}/ef_syntax.c)
ADD_FLEX_BISON_DEPENDENCY(EF_SCANNER EF_PARSER)

# For ef_grammar.h
include_directories(${CMAKE_CURRENT_BINARY_DIR})

add_executable(etterfilter ${EF_SRC} ${FLEX_EF_SCANNER_OUTPUTS} ${BISON_EF_PARSER_OUTPUTS})
target_link_libraries(etterfilter ${EF_LIBS})

## Etterlog

set(EL_SRC
            etterlog/el_analyze.c
            etterlog/el_conn.c
            etterlog/el_decode.c
            etterlog/el_decode_http.c
            etterlog/el_display.c
            etterlog/el_ec_compat.c
            etterlog/el_log.c
            etterlog/el_main.c
            etterlog/el_parser.c
            etterlog/el_profiles.c
            etterlog/el_stream.c
            etterlog/el_target.c
            ${CMAKE_SOURCE_DIR}/src/ec_error.c 
            ${CMAKE_SOURCE_DIR}/src/ec_fingerprint.c 
            ${CMAKE_SOURCE_DIR}/src/ec_manuf.c 
            ${CMAKE_SOURCE_DIR}/src/ec_services.c 
            ${CMAKE_SOURCE_DIR}/src/ec_hash.c 
            ${CMAKE_SOURCE_DIR}/src/ec_file.c 
            ${CMAKE_SOURCE_DIR}/src/ec_inet.c 
            ${CMAKE_SOURCE_DIR}/src/ec_passive.c 
            ${CMAKE_SOURCE_DIR}/src/ec_strings.c 
            ${CMAKE_SOURCE_DIR}/src/ec_format.c
)

if(NOT HAVE_BASENAME)
    set(EL_SRC ${EL_SRC} ${CMAKE_SOURCE_DIR}/src/missing/basename.c)
endif(NOT HAVE_BASENAME)

if(NOT HAVE_STRCASESTR)
    set(EL_SRC ${EL_SRC} ${CMAKE_SOURCE_DIR}/src/missing/strcasestr.c)
endif(NOT HAVE_STRCASESTR)

if(NOT HAVE_STRLCAT)
    set(EL_SRC ${EL_SRC} ${CMAKE_SOURCE_DIR}/src/missing/strlcat.c)
endif(NOT HAVE_STRLCAT)

if(NOT HAVE_STRSEP)
    set(EL_SRC ${EL_SRC} ${CMAKE_SOURCE_DIR}/src/missing/strsep.c)
endif(NOT HAVE_STRSEP)

if(NOT HAVE_MEMMEM)
    set(EL_SRC ${EL_SRC} ${CMAKE_SOURCE_DIR}/src/missing/memmem.c)
endif(NOT HAVE_MEMMEM)

if(NOT HAVE_INET_ATON)
    set(EL_SRC ${EL_SRC} ${CMAKE_SOURCE_DIR}/src/missing/inet_aton.c)
endif(NOT HAVE_INET_ATON)

if(NOT HAVE_GETOPT_LONG)
    set(EL_SRC ${EL_SRC} ${CMAKE_SOURCE_DIR}/src/missing/getopt.c)
endif(NOT HAVE_GETOPT_LONG)

add_executable(etterlog ${EL_SRC})
target_link_libraries(etterlog ${EL_LIBS})

install(TARGETS etterfilter etterlog DESTINATION ${INSTALL_BINDIR})

=== src/interfaces/CMakeLists.txt ===
set(EC_TEXT_SRC
            text/ec_text.c
            text/ec_text_conn.c
            text/ec_text_display.c
            text/ec_text_plugin.c
            text/ec_text_profile.c
)
include_directories(text)

set(EC_DAEMON_SRC daemon/ec_daemon.c)

if(ENABLE_CURSES)
    set(EC_CURSES_SRC 
                curses/ec_curses.c
                curses/ec_curses_filters.c
                curses/ec_curses_help.c
                curses/ec_curses_hosts.c
                curses/ec_curses_live.c
                curses/ec_curses_logging.c
                curses/ec_curses_mitm.c
                curses/ec_curses_offline.c
                curses/ec_curses_plugins.c
                curses/ec_curses_start.c
                curses/ec_curses_targets.c
                curses/ec_curses_view.c
                curses/ec_curses_view_connections.c
                curses/ec_curses_view_profiles.c
    )
    include_directories(curses)
    set(EC_WDG_SRC
                curses/widgets/wdg.c
                curses/widgets/wdg_compound.c
                curses/widgets/wdg_debug.c
                curses/widgets/wdg_dialog.c
                curses/widgets/wdg_dynlist.c
                curses/widgets/wdg_error.c
                curses/widgets/wdg_file.c
                curses/widgets/wdg_input.c
                curses/widgets/wdg_list.c
                curses/widgets/wdg_menu.c
                curses/widgets/wdg_panel.c
                curses/widgets/wdg_percentage.c
                curses/widgets/wdg_scroll.c
                curses/widgets/wdg_window.c
    )
    include_directories(curses/widgets)
    add_library(ec_wdg STATIC ${EC_WDG_SRC})
    target_link_libraries(ec_wdg ${EC_LIBS})
endif(ENABLE_CURSES)

if(ENABLE_GTK)
    set(EC_GTK_SRC
                gtk/ec_gtk.c
                gtk/ec_gtk_conf.c
                gtk/ec_gtk_filters.c
                gtk/ec_gtk_help.c
                gtk/ec_gtk_hosts.c
                gtk/ec_gtk_live.c
                gtk/ec_gtk_logging.c
                gtk/ec_gtk_menus.c
                gtk/ec_gtk_mitm.c
                gtk/ec_gtk_offline.c
                gtk/ec_gtk_plugins.c
                gtk/ec_gtk_start.c
                gtk/ec_gtk_targets.c
                gtk/ec_gtk_view.c
                gtk/ec_gtk_view_connections.c
                gtk/ec_gtk_view_profiles.c
    )
    include_directories(gtk)
endif(ENABLE_GTK)


add_library(ec_interfaces STATIC ${EC_TEXT_SRC} ${EC_DAEMON_SRC} ${EC_WDG_SRC} ${EC_CURSES_SRC} ${EC_GTK_SRC})
target_link_libraries(ec_interfaces ${EC_LIBS})

=== debian/changelog ===
ettercap (1:0.7.5.3-1) unstable; urgency=low

  * New upstream version

 -- Barak A. Pearlmutter <bap@debian.org>  Sat, 02 Feb 2013 18:33:19 +0000

ettercap (1:0.7.5.2-2) unstable; urgency=low

  * Merge ongoing upstream mods per upstream request
    - version number
    - changelog
    - options --certificate and --private-key

 -- Barak A. Pearlmutter <bap@debian.org>  Wed, 30 Jan 2013 15:53:55 +0000

ettercap (1:0.7.5.2-1) unstable; urgency=low

  * New upstream release

 -- Barak A. Pearlmutter <bap@debian.org>  Tue, 29 Jan 2013 16:01:52 +0000

ettercap (1:0.7.5.1-3) unstable; urgency=low

  * remove bogus but harmlessly dead code from patch for CVE-2013-0722

 -- Barak A. Pearlmutter <bap@debian.org>  Thu, 17 Jan 2013 23:19:55 +0000

ettercap (1:0.7.5.1-2) unstable; urgency=low

  * merge upstream patch for CVE-2013-0722 a stack-based buffer overflow
    when parsing hosts list (closes: #697987)
  * merge upstream patch for clang compilation issue

 -- Barak A. Pearlmutter <bap@debian.org>  Mon, 14 Jan 2013 10:19:40 +0000

ettercap (1:0.7.5.1-1) unstable; urgency=low

  * update patches
  * new upstream release

 -- Barak A. Pearlmutter <bap@debian.org>  Fri, 04 Jan 2013 18:16:56 +0100

ettercap (1:0.7.5-5) unstable; urgency=low

  * add version dependency for curl library, per upstream reqs
  * postinst code swizzles doc dirs to symlinks (closes: #693487)

 -- Barak A. Pearlmutter <bap@debian.org>  Sat, 17 Nov 2012 01:07:34 +0000

ettercap (1:0.7.5-4) unstable; urgency=low

  * use proper debhelper documentation directory link option
  * add debugging symbols package ettercap-dbg

 -- Barak A. Pearlmutter <bap@debian.org>  Sun, 28 Oct 2012 22:04:20 +0000

ettercap (1:0.7.5-3) unstable; urgency=low

  * put back version in conflicts with ettercap (closes: #691478)

 -- Barak A. Pearlmutter <bap@debian.org>  Fri, 26 Oct 2012 12:45:37 +0100

ettercap (1:0.7.5-2) unstable; urgency=low

  * build dependency on ghostscript for ps2pdf, used by cmake scripts to
    convert man pages to pdf; not included in the Debian packages.

 -- Barak A. Pearlmutter <bap@debian.org>  Fri, 26 Oct 2012 08:44:51 +0100

ettercap (1:0.7.5-1) unstable; urgency=low

  * New upstream release from new upstream team
    - switch to cmake build system
    - various fiddly fixes (closes: #691465)
  * Modify packaging scripts for new cmake build system.
  * General packaging updates.
  * Depend on menu for su-to-root in menu file (closes: #670840)
  * Misc patches, including
    - gadu-gadu plugin, so avoid removing functionality
    - spelling and man page fixes
    - desktop file and scalable icon
    - post-release upstream patch avoiding sslstrip.so promiscuous linkage

 -- Barak A. Pearlmutter <bap@debian.org>  Fri, 26 Oct 2012 00:20:00 +0100

=== debian/control ===
Source: ettercap
Section: net
Priority: optional
Maintainer: Barak A. Pearlmutter <bap@debian.org>
Uploaders: Murat Demirten <murat@debian.org>
Build-Depends: debhelper (>= 9),
	cmake,
	bison | bison++ | byacc | byacc-j | yacc | btyacc,
	flex | lex,
	libgtk2.0-dev,
	libltdl3-dev,
	libncurses-dev | libncurses5-dev,
	libnet1-dev,
	libpcap-dev | libpcap0.8-dev,
	libpcre3-dev,
	libssl-dev,
	libcurl4-openssl-dev (>= 7.26) | libcurl-ssl-dev | libcurl-dev,
	ghostscript,
Standards-Version: 3.9.4
Homepage: http://ettercap.sourceforge.net
Vcs-Git: git://github.com/barak/ettercap.git
Vcs-Browser: http://github.com/barak/ettercap

Package: ettercap-common
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Recommends: ettercap-graphical | ettercap-text-only
Replaces: ettercap-plugins
Conflicts: ettercap-plugins, ettercap (<= 1:0.7.3)
Description: Multipurpose sniffer/interceptor/logger for switched LAN
 Ettercap supports active and passive dissection of many protocols 
 (even encrypted ones) and includes many feature for network and host 
 analysis.
 .
 Data injection in an established connection and filtering (substitute
 or drop a packet) on the fly is also possible, keeping the connection
 synchronized.
 .
 Many sniffing modes are implemented, for a powerful and complete 
 sniffing suite. It is possible to sniff in four modes: IP Based, MAC Based,
 ARP Based (full-duplex) and PublicARP Based (half-duplex).
 .
 Ettercap also has the ability to detect a switched LAN, and to use OS
 fingerprints (active or passive) to find the geometry of the LAN.
 .
 This package contains the Common support files, configuration files,
 plugins, and documentation.  You must also install either
 ettercap-graphical or ettercap-text-only for the actual GUI-enabled
 or text-only ettercap executable, respectively.

Package: ettercap-text-only
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, ettercap-common (= ${binary:Version})
Replaces: ettercap-gtk, ettercap-graphical, ettercap
Conflicts: ettercap-gtk, ettercap-graphical, ettercap (<= 1:0.7.3)
Provides: ettercap
Description: Ettercap console-mode executable
 Ettercap supports active and passive dissection of many protocols 
 (even encrypted ones) and includes many feature for network and host 
 analysis.
 .
 Data injection in an established connection and filtering (substitute
 or drop a packet) on the fly is also possible, keeping the connection
 synchronized.
 .
 Many sniffing modes are implemented, for a powerful and complete 
 sniffing suite. It is possible to sniff in four modes: IP Based, MAC Based,
 ARP Based (full-duplex) and PublicARP Based (half-duplex).
 .
 Ettercap also has the ability to detect a switched LAN, and to use OS
 fingerprints (active or passive) to find the geometry of the LAN.
 .
 This package contains the ettercap text-mode-only executable.

Package: ettercap-graphical
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, ettercap-common (= ${binary:Version}), menu
Replaces: ettercap-gtk, ettercap-text-only, ettercap
Conflicts: ettercap-gtk, ettercap-text-only, ettercap (<= 1:0.7.3)
Provides: ettercap
Recommends: gksu
Description: Ettercap GUI-enabled executable
 Ettercap supports active and passive dissection of many protocols 
 (even encrypted ones) and includes many feature for network and host 
 analysis.
 .
 Data injection in an established connection and filtering (substitute
 or drop a packet) on the fly is also possible, keeping the connection
 synchronized.
 .
 Many sniffing modes are implemented, for a powerful and complete 
 sniffing suite. It is possible to sniff in four modes: IP Based, MAC Based,
 ARP Based (full-duplex) and PublicARP Based (half-duplex).
 .
 Ettercap also has the ability to detect a switched LAN, and to use OS
 fingerprints (active or passive) to find the geometry of the LAN.
 .
 This package contains the ettercap GUI-enabled executable.

Package: ettercap-dbg
Section: debug
Priority: extra
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends},
	 ettercap-common (= ${binary:Version}),
	 ettercap-graphical (= ${binary:Version}) | ettercap-text-only (= ${binary:Version})
Description: Debug symbols for Ettercap.
 Ettercap runtime debug symbols.

=== debian/rules ===
#!/usr/bin/make -f

%:
	dh $@ --parallel

override_dh_auto_configure:
	@echo main configuration deferred until build, as it must be done twice

# add this when suitable libnet hits Debian: -DENABLE_IPV6=ON
override_dh_auto_build:
	dh_auto_configure -- -DENABLE_GTK=OFF
	dh_auto_build
	mkdir tmp
	mv obj*/src/ettercap ettercap-text-only
	dh_auto_configure -- -DENABLE_GTK=ON
	dh_auto_build

override_dh_auto_install:
	dh_auto_install
	mkdir -p debian/tmp/usr/sbin
	install --mode=0755 ettercap-text-only debian/tmp/usr/sbin/

override_dh_install:
	dh_install
	mkdir -p debian/ettercap-text-only/usr/sbin
	install --mode=0755 \
	 debian/tmp/usr/sbin/ettercap-text-only \
	 debian/ettercap-text-only/usr/sbin/ettercap
	-rm --verbose debian/ettercap-common/usr/share/ettercap/ettercap.png

override_dh_installdocs:
	dh_installdocs -pettercap-common
	dh_installdocs -Nettercap-common --link-doc=ettercap-common

override_dh_strip:
	dh_strip --dbg-package=ettercap-dbg

=== debian/watch ===
version=3

# Of historic interest:
# http://githubredir.debian.net/github/drizzt/ettercap \
#  /github/drizzt/ettercap/NG-(.*)[.]tar[.]gz

# Primary repo:
http://githubredir.debian.net/github/Ettercap/ettercap \
 /github/Ettercap/ettercap/v(\d.*)\.(?:tgz|zip|tar\.(?:gz|bz2|xz))

# Old unused repo
# Bart Martens <bartm@debian.org>  Thu, 15 Nov 2012 10:39:31 +0000
http://qa.debian.org/watch/sf.php/ettercap/ettercap-(\d.*)\.(?:tgz|zip|tar\.(?:gz|bz2|xz))

## ettercap 0.7.6

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,7 +1,7 @@
 cmake_minimum_required(VERSION 2.8)
 project(ettercap C)
 
-set(VERSION "0.7.5")
+set(VERSION "0.7.6")
 
 option(ENABLE_CURSES "Enable curses interface" ON)
 option(ENABLE_GTK "Enable GTK interface" ON)
@@ -12,7 +12,10 @@
 set(MACPORTS_BASE_DIRECTORY "/opt/local" CACHE PATH "MacPorts installation base directory")
 set(SPECIAL_LIB_DIR "" CACHE PATH "Special (non-traditional) directory where libraries are installed")
 
+set(CMAKE_MODULE_PATH "${CMAKE_SOURCE_DIR}/CMakeModules")
+
 include(CMakeModules/CheckVariableInHeaders.cmake)
+include(CMakeModules/FindLIBNET.cmake)
 include(CMakeFiles/os_test.cmake)
 
 #Check and see if we're running Darwin, specify the CMAKE_LIBARY_PATH to do so
@@ -49,7 +52,6 @@
 set(CMAKE_MODULE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} -Wl,-export-dynamic" CACHE STRING "" FORCE)
 endif(OS_DARWIN)
 
-set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} ${CMAKE_SOURCE_DIR}/CMakeModules)
 
 
 include_directories(include)
@@ -74,3 +76,20 @@
 # This line should ALWAYS be after all options are defined
 configure_file(include/config.h.cmake ${CMAKE_SOURCE_DIR}/include/config.h)
 
+
+# Add a target that will ensure that the build directory is properly cleaned.
+add_custom_target(clean-all
+  COMMAND ${CMAKE_COMMAND} -P ${CMAKE_SOURCE_DIR}/CMakeFiles/clean-all.cmake
+)
+
+# If we notice that this isn't the first time they've run 
+if(NOT ("${CMAKE_CACHEFILE_DIR}" STREQUAL ""))
+  message("")
+  message("HAVING TROUBLE BUILDING ETTERCAP? ")
+  message("")
+  message("  1. Install any missing dependencies")
+  message("  2. run 'make clean-all'")
+  message("  3. run 'cmake ${CMAKE_SOURCE_DIR}'")
+  message("")
+endif(NOT ("${CMAKE_CACHEFILE_DIR}" STREQUAL ""))
+

=== plug-ins/CMakeLists.txt ===
--- 
+++ 
@@ -1,4 +1,3 @@
-
 add_library(arp_cop MODULE arp_cop/arp_cop.c)
 set_target_properties(arp_cop PROPERTIES PREFIX "ec_")
 
@@ -49,9 +48,18 @@
 add_library(nbns_spoof MODULE nbns_spoof/nbns_spoof.c)
 set_target_properties(nbns_spoof PROPERTIES PREFIX "ec_")
 
-add_library(sslstrip MODULE sslstrip/sslstrip.c)
-target_link_libraries(sslstrip ${FOUND_LIBCURL} ${HAVE_PCRE})
-set_target_properties(sslstrip PROPERTIES PREFIX "ec_")
+if(HAVE_PCRE)
+    if(CURL_FOUND)
+        add_library(sslstrip MODULE sslstrip/sslstrip.c)
+        target_link_libraries(sslstrip ${CURL_LIBRARY} ${HAVE_PCRE})
+        set_target_properties(sslstrip PROPERTIES PREFIX "ec_")
+        set(SSL_STRIP_PLUGIN sslstrip)
+    else(CURL_FOUND)
+        message(STATUS "Not building sslstrip plugin. Requires libcurl.")
+    endif(CURL_FOUND)
+else(HAVE_PCRE)
+    message(STATUS "Not building sslstrip plugin. Requires pcre.")
+endif(HAVE_PCRE)
 
 add_library(pptp_chapms1 MODULE pptp_chapms1/pptp_chapms1.c)
 set_target_properties(pptp_chapms1 PROPERTIES PREFIX "ec_")
@@ -111,7 +119,7 @@
 isolate
 link_type
 nbns_spoof
-sslstrip
+${SSL_STRIP_PLUGIN}
 pptp_chapms1
 pptp_clear
 pptp_pap
@@ -148,7 +156,7 @@
             isolate
             link_type
             nbns_spoof
-	    sslstrip
+            ${SSL_STRIP_PLUGIN}
             pptp_chapms1
             pptp_clear
             pptp_pap

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -58,6 +58,7 @@
         dissectors/ec_irc.c
         dissectors/ec_iscsi.c
         dissectors/ec_ldap.c
+        dissectors/ec_mdns.c
         dissectors/ec_mongodb.c
         dissectors/ec_mountd.c
         dissectors/ec_msn.c
@@ -97,6 +98,7 @@
         protocols/ec_gre.c
         protocols/ec_icmp.c
         protocols/ec_ip.c
+        protocols/ec_ppi.c
         protocols/ec_ppp.c
         protocols/ec_prism.c
         protocols/ec_radiotap.c

=== debian/changelog ===
ettercap (1:0.7.6-1~ubuntu12.10.1) quantal-backports; urgency=low

  * No-change backport to quantal (LP: #1161379)

 -- Felix Geyer <debfx@ubuntu.com>  Wed, 01 May 2013 18:01:01 +0200

ettercap (1:0.7.6-1) unstable; urgency=low

  [ Gianfranco Costamagna ]
  * New upstream version
  * Dropped version dependency for curl (fixed in cmake)

  [ Barak A. Pearlmutter ]
  * Tweak debian/watch to point to official upstream only

 -- Barak A. Pearlmutter <bap@debian.org>  Wed, 27 Mar 2013 11:44:17 +0000

ettercap (1:0.7.5.3-2) unstable; urgency=low

  * tweak debian/rules to enable IPv6 with libnet 1.1.6 or greater

 -- Barak A. Pearlmutter <bap@debian.org>  Mon, 25 Feb 2013 22:34:29 +0000

=== debian/control ===
--- 
+++ 
@@ -14,7 +14,7 @@
 	libpcap-dev | libpcap0.8-dev,
 	libpcre3-dev,
 	libssl-dev,
-	libcurl4-openssl-dev (>= 7.26) | libcurl-ssl-dev | libcurl-dev,
+	libcurl4-openssl-dev | libcurl-ssl-dev | libcurl-dev,
 	ghostscript,
 Standards-Version: 3.9.4
 Homepage: http://ettercap.sourceforge.net

=== debian/rules ===
--- 
+++ 
@@ -3,16 +3,25 @@
 %:
 	dh $@ --parallel
 
+LIBNET_VER := $(shell dpkg --status libnet1-dev | awk '/^Version:/ {print $$2}')
+
+ENABLE_IPV6 := $(shell \
+ if dpkg --compare-versions $(LIBNET_VER) ge 1.1.6; \
+ then echo ON; \
+ else echo OFF; \
+ fi)
+
 override_dh_auto_configure:
+	@echo LIBNET_VER = $(LIBNET_VER)
+	@echo ENABLE_IPV6 = $(ENABLE_IPV6)
 	@echo main configuration deferred until build, as it must be done twice
 
-# add this when suitable libnet hits Debian: -DENABLE_IPV6=ON
 override_dh_auto_build:
-	dh_auto_configure -- -DENABLE_GTK=OFF
+	dh_auto_configure -- -DENABLE_IPV6=$(ENABLE_IPV6) -DENABLE_GTK=OFF
 	dh_auto_build
 	mkdir tmp
 	mv obj*/src/ettercap ettercap-text-only
-	dh_auto_configure -- -DENABLE_GTK=ON
+	dh_auto_configure -- -DENABLE_IPV6=$(ENABLE_IPV6) -DENABLE_GTK=ON
 	dh_auto_build
 
 override_dh_auto_install:

=== debian/watch ===
version=3

http://ettercap.github.com/ettercap/downloads.html \
(?:.*[/=]|)ettercap[_\-](\d.*)\.(?:tgz|tbz2|txz|tar\.(?:gz|bz2|xz)).*
